<template>
  <div>
    <v-btn small color="grey" dark @click="showModal = true">
      <v-icon dark>mdi-plus</v-icon>
      Ajouter un ingrédient
    </v-btn>
    <v-dialog v-model="showModal" max-width="450">
      <v-card>
        <v-card-title>
          <span class="headline">
            <v-icon>fa-carrot</v-icon>
            Nouvel ingrédient
          </span>
        </v-card-title>
        <v-card-text>
          <v-container>
            <v-text-field outlined label="Nom de l'ingrédient" v-model="ingredientName" required></v-text-field>
          </v-container>
          <small>Les images de l'ingrédient sont automatiquement ajoutées.</small>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="blue darken-1" text @click="showModal = false">Annuler</v-btn>
          <v-btn color="blue darken-1" text @click="submitIngredient()">Ajouter</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </div>
</template>

<script lang="ts">
import VueWithMixins from "../../../assets/VueWithMixins";
import Component from "vue-class-component";
import { Watch } from "vue-property-decorator";
import IngredientService from "../../../services/IngredientService";

@Component
export default class IngredientFormModal extends VueWithMixins {
  showModal: boolean = false;
  ingredientName: string = "";
  ingredientService: IngredientService = null;

  mounted() {
    this.ingredientService = new IngredientService();
  }

  private submitIngredient() {
    this.ingredientService.createIngredient(this.ingredientName).then(res => {
      this.Toast.success(
        "Ingrédient ajouté avec succès, vous pouvez dorénavant l'ajouter à votre recette"
      );
      this.ingredientName = "";
      this.showModal = false;
    });
  }
}
</script>